> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.shipbob.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.shipbob.com/_mcp/server.

# Add new product variants to a product


POST https://api.shipbob.com/Experimental/variant/{variantId}:convertToBundle
Content-Type: application/json-patch+json

Reference: https://developer.shipbob.com/experimental/api/products/add-new-product-variants-to-a-product

## Authentication

- `Authorization` header (bearer token, required) — Authentication using Personal Access Token (PAT) token
- `Authorization` header (bearer token, required) — OAuth2 authentication using JWT tokens

## Servers

- `https://api.shipbob.com` (https://api.shipbob.com, default)
- `https://sandbox-api.shipbob.com` (https://sandbox-api.shipbob.com)

## Request

### Path parameters

- `variantId` (long, required)

### Body (application/json-patch+json)

- `bundle_definition` (list of object, optional)
  - `quantity` (integer, optional)
  - `variant_id` (long, optional)
- `channel_metadata` (list of object or object or object or object, optional)
  - Products.AmazonChannelMetadataRequestModel
    - `asin` (string, optional)
    - `channel_id` (integer, optional)
    - `currency` (string, optional)
    - `fnsku` (string, optional)
    - `fulfillment_channel` (string, optional)
    - `id` (long, optional)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional)
    - `platform` (string, optional)
    - `platform_identifier` (string, optional)
    - `platform_inventory_item_id` (string, optional)
    - `price` (double, optional)
    - `seller_sku` (string, optional)
  - Products.BaseChannelMetadataRequestModel
    - `channel_id` (integer, optional)
    - `currency` (string, optional)
    - `id` (long, optional)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional)
    - `platform` (string, optional)
    - `platform_identifier` (string, optional)
    - `platform_inventory_item_id` (string, optional)
    - `price` (double, optional)
    - `seller_sku` (string, optional)
  - Products.BigCommerceChannelMetadataRequestModel
    - `channel_id` (integer, optional)
    - `currency` (string, optional)
    - `id` (long, optional)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional)
    - `platform` (string, optional)
    - `platform_identifier` (string, optional)
    - `platform_inventory_item_id` (string, optional)
    - `platform_product_id` (long, optional)
    - `platform_variant_id` (long, optional)
    - `price` (double, optional)
    - `seller_sku` (string, optional)
  - Products.ShopifyChannelMetadataRequestModel
    - `channel_id` (integer, optional)
    - `currency` (string, optional)
    - `id` (long, optional)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional)
    - `platform` (string, optional)
    - `platform_identifier` (string, optional)
    - `platform_inventory_item_id` (string, optional)
    - `price` (double, optional)
    - `seller_sku` (string, optional)
- `name` (string, optional)
- `sku` (string, optional)

## Response

### 201

Created

- `created_on` (datetime, optional)
- `id` (long, optional)
- `name` (string, optional)
- `taxonomy` (object, optional)
  - `id` (integer, optional)
  - `name` (string, optional)
  - `parent_id` (integer, optional)
  - `parent_name` (string, optional)
  - `path` (string, optional)
- `type` (string, optional)
- `updated_on` (datetime, optional)
- `user_id` (long, optional)
- `variants` (list of object, optional)
  - `additional_hazmat_attributes` (object, optional)
    - `charge_state_percentage` (double, optional)
    - `container_metal` (boolean, optional)
    - `lithium_battery_packaging` (string, optional)
    - `lithium_battery_type` (string, optional)
    - `magnet` (boolean, optional)
    - `net_volume` (double, optional)
    - `net_weight` (double, optional)
  - `associated_bundles` (list of object, optional)
    - `product_id` (long, optional)
    - `product_name` (string, optional)
    - `quantity` (integer, optional)
    - `variant_id` (long, optional)
    - `variant_sku` (string, optional)
  - `barcodes` (list of object, optional)
    - `sticker_url` (string, optional)
    - `value` (string, optional)
  - `bundle_definition` (list of object, optional)
    - `product_id` (long, optional)
    - `quantity` (integer, optional)
    - `variant_id` (long, optional)
    - `variant_name` (string, optional)
    - `variant_sku` (string, optional)
  - `channel_metadata` (list of object or object or object or object, optional)
    - Products.ChannelMetadataViewModel
      - `channel_id` (long, optional)
      - `channel_name` (string, optional)
      - `currency` (string, optional)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional)
      - `platform` (string, optional)
      - `platform_identifier` (string, optional)
      - `platform_inventory_item_id` (string, optional)
      - `price` (double, optional)
      - `seller_sku` (string, optional)
    - Products.AmazonChannelMetadataViewModel
      - `asin` (string, optional)
      - `channel_id` (long, optional)
      - `channel_name` (string, optional)
      - `currency` (string, optional)
      - `fnsku` (string, optional)
      - `fulfillment_channel` (string, optional)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional)
      - `platform` (string, optional)
      - `platform_identifier` (string, optional)
      - `platform_inventory_item_id` (string, optional)
      - `price` (double, optional)
      - `seller_sku` (string, optional)
    - Products.BigCommerceChannelMetadataViewModel
      - `channel_id` (long, optional)
      - `channel_name` (string, optional)
      - `currency` (string, optional)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional)
      - `platform` (string, optional)
      - `platform_identifier` (string, optional)
      - `platform_inventory_item_id` (string, optional)
      - `platform_product_id` (long, optional)
      - `platform_variant_id` (long, optional)
      - `price` (double, optional)
      - `seller_sku` (string, optional)
    - Products.ShopifyChannelMetadataViewModel
      - `channel_id` (long, optional)
      - `channel_name` (string, optional)
      - `currency` (string, optional)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional)
      - `platform` (string, optional)
      - `platform_identifier` (string, optional)
      - `platform_inventory_item_id` (string, optional)
      - `price` (double, optional)
      - `seller_sku` (string, optional)
  - `created_on` (datetime, optional)
  - `customs` (object, optional)
    - `country_code_of_origin` (string, optional)
    - `currency` (string, optional)
    - `description` (string, optional)
    - `hs_tariff_code` (string, optional)
    - `is321_eligible` (boolean, optional)
    - `value` (integer, optional)
  - `dimension` (object, optional)
    - `height` (double, optional)
    - `is_locked` (boolean, optional)
    - `length` (double, optional)
    - `source` (string, optional)
    - `unit` (string, optional)
    - `width` (double, optional)
  - `fulfillment_settings` (object, optional)
    - `dangerous_goods` (boolean, optional)
    - `is_bpm_parcel` (boolean, optional)
    - `is_case_pick` (boolean, optional)
    - `msds_url` (string, optional)
    - `requires_prop65` (boolean, optional)
    - `serial_scan` (object, optional)
      - `exact_character_length` (integer, optional)
      - `is_enabled` (boolean, optional)
      - `prefix` (string, optional)
      - `suffix` (string, optional)
  - `gtin` (string, optional)
  - `id` (long, optional)
  - `inventory` (object, optional)
    - `inventory_id` (integer, optional)
    - `on_hand_qty` (integer, optional)
  - `is_digital` (boolean, optional)
  - `is_image_uploaded` (boolean, optional)
  - `lot_information` (object, optional)
    - `is_lot` (boolean, optional)
    - `minimum_shelf_life_days` (integer, optional)
  - `merge_children` (list of object, optional)
    - `channel_ids` (list of long, optional)
    - `completed_at` (datetime, optional)
    - `inventory_id` (long, optional)
    - `variant_id` (long, optional)
    - `variant_name` (string, optional)
  - `name` (string, optional)
  - `packaging_material_type` (object, optional)
    - `id` (long, optional)
    - `name` (string, optional)
  - `packaging_requirement` (object, optional)
    - `id` (long, optional)
    - `name` (string, optional)
  - `return_preferences` (object, optional)
    - `backup_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional)
    - `instructions` (string, optional)
    - `primary_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional)
    - `return_to_sender_backup_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional)
    - `return_to_sender_primary_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional)
  - `reviews_pending` (list of string, optional)
  - `sku` (string, optional)
  - `status` (string, optional)
  - `upc` (string, optional)
  - `updated_on` (datetime, optional)
  - `weight` (object, optional)
    - `unit` (string, optional)
    - `weight` (double, optional)

## Examples

**Request**

```json
{
  "bundle_definition": [
    {
      "quantity": 0,
      "variant_id": 0
    }
  ],
  "channel_metadata": [
    {
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string",
      "platform": "string"
    }
  ],
  "name": "string",
  "sku": "string"
}
```

**Response**

```json
{
  "created_on": "2019-08-24T14:15:22+00:00",
  "id": 0,
  "name": "string",
  "taxonomy": {
    "id": 0,
    "name": "string",
    "parent_id": 0,
    "parent_name": "string",
    "path": "string"
  },
  "type": "string",
  "updated_on": "2019-08-24T14:15:22+00:00",
  "user_id": 0,
  "variants": [
    {
      "additional_hazmat_attributes": {
        "charge_state_percentage": 0.1,
        "container_metal": true,
        "lithium_battery_packaging": "string",
        "lithium_battery_type": "string",
        "magnet": true,
        "net_volume": 0.1,
        "net_weight": 0.1
      },
      "associated_bundles": [
        {
          "product_id": 0,
          "product_name": "string",
          "quantity": 0,
          "variant_id": 0,
          "variant_sku": "string"
        }
      ],
      "barcodes": [
        {
          "sticker_url": "string",
          "value": "string"
        }
      ],
      "bundle_definition": [
        {
          "product_id": 0,
          "quantity": 0,
          "variant_id": 0,
          "variant_name": "string",
          "variant_sku": "string"
        }
      ],
      "channel_metadata": [
        {
          "channel_id": 0,
          "channel_name": "string",
          "currency": "string",
          "id": 0,
          "is_inventory_sync_enabled": true,
          "legacy_product_id": 0,
          "platform": "string",
          "platform_identifier": "string",
          "platform_inventory_item_id": "string",
          "price": 0.1,
          "seller_sku": "string"
        }
      ],
      "created_on": "2019-08-24T14:15:22+00:00",
      "customs": {
        "country_code_of_origin": "string",
        "currency": "string",
        "description": "string",
        "hs_tariff_code": "string",
        "is321_eligible": true,
        "value": 0
      },
      "dimension": {
        "height": 0.1,
        "is_locked": true,
        "length": 0.1,
        "source": "string",
        "unit": "string",
        "width": 0.1
      },
      "fulfillment_settings": {
        "dangerous_goods": true,
        "is_bpm_parcel": true,
        "is_case_pick": true,
        "msds_url": "string",
        "requires_prop65": true,
        "serial_scan": {
          "exact_character_length": 0,
          "is_enabled": true,
          "prefix": "string",
          "suffix": "string"
        }
      },
      "gtin": "string",
      "id": 0,
      "inventory": {
        "inventory_id": 0,
        "on_hand_qty": 0
      },
      "is_digital": true,
      "is_image_uploaded": true,
      "lot_information": {
        "is_lot": true,
        "minimum_shelf_life_days": 0
      },
      "merge_children": [
        {
          "channel_ids": [
            0
          ],
          "completed_at": "2019-08-24T14:15:22+00:00",
          "inventory_id": 0,
          "variant_id": 0,
          "variant_name": "string"
        }
      ],
      "name": "string",
      "packaging_material_type": {
        "id": 0,
        "name": "string"
      },
      "packaging_requirement": {
        "id": 0,
        "name": "string"
      },
      "return_preferences": {
        "backup_action": {
          "id": 0,
          "name": "string"
        },
        "instructions": "string",
        "primary_action": {
          "id": 0,
          "name": "string"
        },
        "return_to_sender_backup_action": {
          "id": 0,
          "name": "string"
        },
        "return_to_sender_primary_action": {
          "id": 0,
          "name": "string"
        }
      },
      "reviews_pending": [
        "string"
      ],
      "sku": "string",
      "status": "string",
      "upc": "string",
      "updated_on": "2019-08-24T14:15:22+00:00",
      "weight": {
        "unit": "string",
        "weight": 0.1
      }
    }
  ]
}
```

**SDK Code**

```python default
import requests

url = "https://api.shipbob.com/Experimental/variant/1:convertToBundle"

payload = "{\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\",\n      \"platform\": \"string\"\n    }\n  ],\n  \"name\": \"string\",\n  \"sku\": \"string\"\n}"
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json-patch+json"
}

response = requests.post(url, data=payload, headers=headers)

print(response.json())
```

```javascript default
const url = 'https://api.shipbob.com/Experimental/variant/1:convertToBundle';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json-patch+json'},
  body: '{\n  "bundle_definition": [\n    {\n      "quantity": 0,\n      "variant_id": 0\n    }\n  ],\n  "channel_metadata": [\n    {\n      "asin": "string",\n      "fnsku": "string",\n      "fulfillment_channel": "string",\n      "channel_id": 0,\n      "currency": "string",\n      "id": 0,\n      "is_inventory_sync_enabled": true,\n      "legacy_product_id": 0,\n      "platform_identifier": "string",\n      "platform_inventory_item_id": "string",\n      "price": 0.1,\n      "seller_sku": "string",\n      "platform": "string"\n    }\n  ],\n  "name": "string",\n  "sku": "string"\n}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go default
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/Experimental/variant/1:convertToBundle"

	payload := strings.NewReader("{\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\",\n      \"platform\": \"string\"\n    }\n  ],\n  \"name\": \"string\",\n  \"sku\": \"string\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json-patch+json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby default
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/Experimental/variant/1:convertToBundle")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json-patch+json'
request.body = "{\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\",\n      \"platform\": \"string\"\n    }\n  ],\n  \"name\": \"string\",\n  \"sku\": \"string\"\n}"

response = http.request(request)
puts response.read_body
```

```java default
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.shipbob.com/Experimental/variant/1:convertToBundle")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json-patch+json")
  .body("{\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\",\n      \"platform\": \"string\"\n    }\n  ],\n  \"name\": \"string\",\n  \"sku\": \"string\"\n}")
  .asString();
```

```php default
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.shipbob.com/Experimental/variant/1:convertToBundle', [
  'body' => '{
  "bundle_definition": [
    {
      "quantity": 0,
      "variant_id": 0
    }
  ],
  "channel_metadata": [
    {
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string",
      "platform": "string"
    }
  ],
  "name": "string",
  "sku": "string"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json-patch+json',
  ],
]);

echo $response->getBody();
```

```csharp default
using RestSharp;

var client = new RestClient("https://api.shipbob.com/Experimental/variant/1:convertToBundle");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json-patch+json");
request.AddParameter("application/json-patch+json", "{\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\",\n      \"platform\": \"string\"\n    }\n  ],\n  \"name\": \"string\",\n  \"sku\": \"string\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift default
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json-patch+json"
]

let postData = NSData(data: "{
  "bundle_definition": [
    {
      "quantity": 0,
      "variant_id": 0
    }
  ],
  "channel_metadata": [
    {
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string",
      "platform": "string"
    }
  ],
  "name": "string",
  "sku": "string"
}".data(using: String.Encoding.utf8)!)

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/Experimental/variant/1:convertToBundle")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```